import { RestPathParams } from './RestRequestParams';
import { RestRequestBody } from './RestRequestBody';
import { RestResponseBody } from './RestResponseBody';
import { RestQueryParams } from './RestQueryParams';
import { RestRequestHeaders } from './RestRequestHeaders';
export type RestApiRequestHandler<PathParams extends RestPathParams, QueryParams extends RestQueryParams, RequestHeaders extends RestRequestHeaders, RequestBody extends RestRequestBody, ResponseBody extends RestResponseBody> = (request: ApiRouteRequest<PathParams, QueryParams, RequestHeaders, RequestBody>) => Promise<ApiRouteResponse<ResponseBody>>;
export interface ApiRouteRequest<PathParams, QueryParams, RequestHeaders, RequestBody> {
    pathParams: PathParams;
    headers: RequestHeaders;
    queryParams: QueryParams;
    body: RequestBody;
}
export interface ApiRouteResponse<ResponseBody> {
    status: number;
    headers?: Record<string, string>;
    body?: ResponseBody;
}
